import java.util.List;
import java.util.ArrayList;
import java.util.Arrays;


/**
   This program demonstrates a generic insertion sort
   method that sorts an array of type T items that
   implement the Comparable<T> interface.
*/
public class GenericInsertionSort_ver1
{
   public static void main(String[] args)
   {
      Triple[] array1 = { new Triple(2, 3, 2),
                          new Triple(4, 4, 1),
                          new Triple(2, 4, 0),
                          new Triple(5, 1, 1),
                          new Triple(0, 6, 3),
                          new Triple(2, 2, 2),
                          new Triple(4, 1, 4),
                          new Triple(5, 0, 4)};
      System.out.println(Arrays.toString(array1));
      sort(array1);
      System.out.println(Arrays.toString(array1));
      System.out.println();


      Country[] array2 = { new Country("Freedonia", 3, 1),
                           new Country("Shire", 5000, 50),
                           new Country("Ambrosia", 10, 20),
                           new Country("Utopia", 1000, 1000000),
                           new Country("Neverland", 0, 0),
                           new Country("Elbonia", 10, 20)};
      System.out.println(Arrays.toString(array2));
      sort(array2);
      System.out.println(Arrays.toString(array2));
      System.out.println();


      Pair[] array3 = { new Pair(3, 1),
                        new Pair(10, 20),
                        new Pair(3, 0),
                        new Pair(0, 0)};
      System.out.println(Arrays.toString(array3));
    //sort(array3); // Does not work! Pair is not Comparable.
    //System.out.println(Arrays.toString(array3));
   }



   /**
      Sort an array of Comparable<T> objects using
      the iterative insertion sort algorithm.

      @param a  the array of Comparable<T> objects to sort
   */
   public static <T extends Comparable<T>> void sort(T[] a)
   {
      for (int i = 1; i < a.length; ++i)
      {
         T next = a[i];
         // Move all larger elements up.
         int j = i;
         while (j > 0 && a[j - 1].compareTo(next) > 0)
         {
            a[j] = a[j - 1];
            j--;
         }
         // Insert the element.
         a[j] = next;
      }
   }
}
