import java.util.List;
import java.util.ArrayList;
import java.util.Arrays;


/**
   This program demonstrates a generic insertion sort
   method that sorts a List<T> of items that implement
   the Comparable<T> interface.
*/
public class GenericInsertionSort_ver3
{
   public static void main(String[] args)
   {
      List<Triple> list1 = new ArrayList<>(
                                 Arrays.asList(
                                   new Triple(2, 3, 2),
                                   new Triple(4, 4, 1),
                                   new Triple(2, 4, 0),
                                   new Triple(5, 1, 1),
                                   new Triple(0, 6, 3),
                                   new Triple(2, 2, 2),
                                   new Triple(4, 1, 4),
                                   new Triple(5, 0, 4) ) );
      System.out.println(list1);
      sort(list1);
      System.out.println(list1);
      System.out.println();


      List<Country> list2 = new ArrayList<>(
                                  Arrays.asList(
                                    new Country("Freedonia", 3, 1),
                                    new Country("Shire", 5000, 50),
                                    new Country("Ambrosia", 10, 20),
                                    new Country("Utopia", 1000, 1000000),
                                    new Country("Neverland", 0, 0),
                                    new Country("Elbonia", 10, 20) ) );
      System.out.println(list2);
      sort(list2);
      System.out.println(list2);
      System.out.println();


      List<Pair> list3 = new ArrayList<>(
                               Arrays.asList(
                                 new Pair(3, 1),
                                 new Pair(10, 20),
                                 new Pair(3, 0),
                                 new Pair(0, 0) ) );
      System.out.println(list3);
    //sort(list3); // Does not work! Pair is not Comparable.
    //System.out.println(list3);
   }



   /**
      Sort a List of Comparable<T> objects using
      the iterative insertion sort algorithm.

      @param list  the List<T> to sort
   */
   public static <T extends Comparable<T>> void sort(List<T> list)
   {
      for (int i = 1; i < list.size(); ++i)
      {
         T next = list.remove(i);
         // Insert next into the list where it belongs.
         int j = i;
         while (j > 0 && list.get(j - 1).compareTo(next) > 0)
         {
            j--;
         }
         // Insert the element.
         list.add(j, next);
      }
   }
}
