/**
   This version of the Pair class does NOT
   implement the Comparable<T> interface.

   We cannot use this class with a generic sorting
   method that expects Comparable<T> objects.

   But we can define a Comparator<Pair> object for
   this Pair class and then use a generic sorting
   method that works with a Comparator<T> object.
*/
public class Pair
{
   public int x, y;

   public Pair(int x, int y)
   {
      this.x = x;
      this.y = y;
   }


   @Override public String toString()
   {
      return "<" + x + ", " + y + ">";
   }
}
